<template>  
<div>
    <div :class="['app-list',this.items.length > 0 ? '' : 'app-list-empty' ]">
        <div v-if="items.length > 0">
            <div v-for = "item in items" :key="item.srfkey"  :class="['app-list-item', {'isSelect': item.isselected === true ? true : false}]" @click="handleClick(item)"  @dblclick="handleDblClick(item)">
                <div class="app-list-item-content">
                    <div class="item-icon">
                        <template v-if="item.srficon">
                            <img :src="item.srficon" />
                        </template>
                        <template v-else>
                            <img src="/assets/img/noimage.png"/>
                        </template>
                    </div>
                    <template>
                        <div class="item-content-text">
                            <span class="item-text">{{item.srfmajortext}}</span>
                            <span v-if="item.srfdescription" class="item-subtext">{{ item.srfdescription }}</span>
                        </div>
                    </template>
                </div>
                <div v-if="item.srfdate" class="app-list-item-date">
                    <span class="date">{{ item.srfdate }}</span>
                </div>
                <div class="app-list-item-action">
                    <template v-for="(action,index) in Object.keys(ActionModel)">
                        <a :key="index" style="display: inline-block;margin: 0 12px;" @click="uiAction(item, action, $event)">
                            <i :class="ActionModel[action].icon" style="margin-right:2px;"></i>
                            <span>{{ActionModel[action].caption}}</span>
                        </a>
                    </template>
                </div>
            </div>
            <template v-if="isScrollBar">
            <div v-if="totalRecord>items.length" class="loadmore">{{ this.$t('app.commonWords.loadmore') }}</div>
            <div v-else class="loadmore">{{ this.$t('app.commonWords.nomore') }}</div>
            </template>
        </div>
        <div v-else>
            {{ $t('entities.ibizbook.lnternalfunclist_list.nodata') }}
            <span class="quick-toolbar">
                            <div class='toolbar-container'>
                <tooltip :transfer="true" :max-width="600">
                        <i-button v-show="listviewlist_quicktoolbarModels.deuiaction1.visabled" :disabled="listviewlist_quicktoolbarModels.deuiaction1.disabled" class='' v-loading:i-button @click="list_quicktoolbar_click({ tag: 'deuiaction1' }, $event)">
                            <i class='fa fa-file-text-o'></i>
                            <span class='caption'>{{$t('entities.ibizbook.listviewlist_quicktoolbar_toolbar.deuiaction1.caption')}}</span>
                        </i-button>
                    <div slot='content'>{{$t('entities.ibizbook.listviewlist_quicktoolbar_toolbar.deuiaction1.tip')}}</div>
                </tooltip>
            </div>
            </span>
        </div>
        <el-backtop target=".content-container .app-list"></el-backtop>
    </div>
    <row class='list-pagination' v-if="selections.length > 0">
        <span class="batch-toolbar">
                    <div class='toolbar-container'>
                <tooltip :transfer="true" :max-width="600">
                        <i-button v-show="listviewlist_batchtoolbarModels.deuiaction1.visabled" :disabled="listviewlist_batchtoolbarModels.deuiaction1.disabled" class='' v-loading:i-button @click="list_batchtoolbar_click({ tag: 'deuiaction1' }, $event)">
                            <i class='fa fa-edit'></i>
                            <span class='caption'>{{$t('entities.ibizbook.listviewlist_batchtoolbar_toolbar.deuiaction1.caption')}}</span>
                        </i-button>
                    <div slot='content'>{{$t('entities.ibizbook.listviewlist_batchtoolbar_toolbar.deuiaction1.tip')}}</div>
                </tooltip>
                <tooltip :transfer="true" :max-width="600">
                        <i-button v-show="listviewlist_batchtoolbarModels.deuiaction2.visabled" :disabled="listviewlist_batchtoolbarModels.deuiaction2.disabled" class='' v-loading:i-button @click="list_batchtoolbar_click({ tag: 'deuiaction2' }, $event)">
                            <i class='fa fa-remove'></i>
                            <span class='caption'>{{$t('entities.ibizbook.listviewlist_batchtoolbar_toolbar.deuiaction2.caption')}}</span>
                        </i-button>
                    <div slot='content'>{{$t('entities.ibizbook.listviewlist_batchtoolbar_toolbar.deuiaction2.tip')}}</div>
                </tooltip>
            </div>
        </span>
    </row>
</div>
</template>
<script lang='tsx'>
import { Vue, Component, Prop, Provide, Emit, Watch, Model,Inject } from 'vue-property-decorator';
import { CreateElement } from 'vue';
import { Subject, Subscription } from 'rxjs';
import { ControlInterface } from '@/interface/control';
import { UIActionTool,Util,ViewTool } from '@/utils';
import NavDataService from '@/service/app/navdata-service';
import AppCenterService from "@service/app/app-center-service";
import IBIZBOOKService from '@/service/ibizbook/ibizbook-service';
import LnternalFuncListService from './lnternal-func-list-list-service';
import IBIZBOOKUIService from '@/uiservice/ibizbook/ibizbook-ui-service';
import CodeListService from "@/codelist/codelist-service";


@Component({
    components: {
      
    }
})
export default class LnternalFuncListBase extends Vue implements ControlInterface {

    /**
     * 名称
     *
     * @type {string}
     * @memberof LnternalFuncListBase
     */
    @Prop() public name?: string;

    /**
     * 视图通讯对象
     *
     * @type {Subject<ViewState>}
     * @memberof LnternalFuncListBase
     */
    @Prop() public viewState!: Subject<ViewState>;

    /**
     * 应用上下文
     *
     * @type {*}
     * @memberof LnternalFuncListBase
     */
    @Prop() public context!: any;

    /**
     * 视图参数
     *
     * @type {*}
     * @memberof LnternalFuncListBase
     */
    @Prop() public viewparams!: any;

    /**
     * 视图状态事件
     *
     * @public
     * @type {(Subscription | undefined)}
     * @memberof LnternalFuncListBase
     */
    public viewStateEvent: Subscription | undefined;

    /**
     * 获取部件类型
     *
     * @returns {string}
     * @memberof LnternalFuncListBase
     */
    public getControlType(): string {
        return 'LIST'
    }



    /**
     * 计数器服务对象集合
     *
     * @type {Array<*>}
     * @memberof LnternalFuncListBase
     */    
    public counterServiceArray:Array<any> = [];

    /**
     * 建构部件服务对象
     *
     * @type {LnternalFuncListService}
     * @memberof LnternalFuncListBase
     */
    public service: LnternalFuncListService = new LnternalFuncListService({ $store: this.$store });

    /**
     * 实体服务对象
     *
     * @type {IBIZBOOKService}
     * @memberof LnternalFuncListBase
     */
    public appEntityService: IBIZBOOKService = new IBIZBOOKService({ $store: this.$store });

    /**
     * list_batchtoolbar 部件 click 事件
     *
     * @param {*} [args={}]
     * @param {*} $event
     * @memberof LnternalFuncListBase
     */
    public list_batchtoolbar_click($event: any, $event2?: any) {
        if (Object.is($event.tag, 'deuiaction1')) {
            this.list_batchtoolbar_deuiaction1_click(null, 'list_batchtoolbar', $event2);
        }
        if (Object.is($event.tag, 'deuiaction2')) {
            this.list_batchtoolbar_deuiaction2_click(null, 'list_batchtoolbar', $event2);
        }
    }

    /**
     * list_quicktoolbar 部件 click 事件
     *
     * @param {*} [args={}]
     * @param {*} $event
     * @memberof LnternalFuncListBase
     */
    public list_quicktoolbar_click($event: any, $event2?: any) {
        if (Object.is($event.tag, 'deuiaction1')) {
            this.list_quicktoolbar_deuiaction1_click(null, 'list_quicktoolbar', $event2);
        }
    }
    

    /**
     * 逻辑事件
     *
     * @param {*} [params={}]
     * @param {*} [tag]
     * @param {*} [$event]
     * @memberof 
     */
    public list_quicktoolbar_deuiaction1_click(params: any = {}, tag?: any, $event?: any) {
        // 参数
        // 取数
        let datas: any[] = [];
        let xData: any = null;
        // _this 指向容器对象
        const _this: any = this;
        let paramJO:any = {};
        let contextJO:any = {};
        xData = this;
        if (_this.getDatas && _this.getDatas instanceof Function) {
            datas = [..._this.getDatas()];
        }
        if(params){
          datas = [params];
        }
        // 界面行为
        this.New(datas, contextJO,paramJO,  $event, xData,this,"IBIZBOOK");
    }

    /**
     * 逻辑事件
     *
     * @param {*} [params={}]
     * @param {*} [tag]
     * @param {*} [$event]
     * @memberof 
     */
    public list_batchtoolbar_deuiaction1_click(params: any = {}, tag?: any, $event?: any) {
        // 参数
        // 取数
        let datas: any[] = [];
        let xData: any = null;
        // _this 指向容器对象
        const _this: any = this;
        let paramJO:any = {};
        let contextJO:any = {};
        xData = this;
        if (_this.getDatas && _this.getDatas instanceof Function) {
            datas = [..._this.getDatas()];
        }
        if(params){
          datas = [params];
        }
        // 界面行为
        this.Edit(datas, contextJO,paramJO,  $event, xData,this,"IBIZBOOK");
    }

    /**
     * 逻辑事件
     *
     * @param {*} [params={}]
     * @param {*} [tag]
     * @param {*} [$event]
     * @memberof 
     */
    public list_batchtoolbar_deuiaction2_click(params: any = {}, tag?: any, $event?: any) {
        // 参数
        // 取数
        let datas: any[] = [];
        let xData: any = null;
        // _this 指向容器对象
        const _this: any = this;
        let paramJO:any = {};
        let contextJO:any = {};
        xData = this;
        if (_this.getDatas && _this.getDatas instanceof Function) {
            datas = [..._this.getDatas()];
        }
        if(params){
          datas = [params];
        }
        // 界面行为
        this.Remove(datas, contextJO,paramJO,  $event, xData,this,"IBIZBOOK");
    }

    /**
     * 新建
     *
     * @param {any[]} args 当前数据
     * @param {any} contextJO 行为附加上下文
     * @param {*} [params] 附加参数
     * @param {*} [$event] 事件源
     * @param {*} [xData]  执行行为所需当前部件
     * @param {*} [actionContext]  执行行为上下文
     * @memberof IBIZBOOKListViewBase
     */
    public New(args: any[],contextJO?:any, params?: any, $event?: any, xData?: any,actionContext?:any,srfParentDeName?:string) {
         const _this: any = this;
        if (_this.newdata && _this.newdata instanceof Function) {
            const data: any = {};
            _this.newdata([{ ...data }],[{ ...data }], params, $event, xData);
        } else {
            _this.$Notice.error({ title: '错误', desc: 'newdata 视图处理逻辑不存在，请添加!' });
        }
    }
    /**
     * 编辑
     *
     * @param {any[]} args 当前数据
     * @param {any} contextJO 行为附加上下文
     * @param {*} [params] 附加参数
     * @param {*} [$event] 事件源
     * @param {*} [xData]  执行行为所需当前部件
     * @param {*} [actionContext]  执行行为上下文
     * @memberof IBIZBOOKListViewBase
     */
    public Edit(args: any[],contextJO?:any, params?: any, $event?: any, xData?: any,actionContext?:any,srfParentDeName?:string) {
        if (args.length === 0) {
            return;
        }
        const _this: any = this;
        if (_this.opendata && _this.opendata instanceof Function) {
            const data: any = { };
            if (args.length > 0) {
                Object.assign(data, { ibizbook: args[0].ibizbook })
            }
            _this.opendata([{ ...data }], params, $event, xData);
        } else {
            _this.$Notice.error({ title: '错误', desc: 'opendata 视图处理逻辑不存在，请添加!' });
        }
    }
    /**
     * 删除
     *
     * @param {any[]} args 当前数据
     * @param {any} contextJO 行为附加上下文
     * @param {*} [params] 附加参数
     * @param {*} [$event] 事件源
     * @param {*} [xData]  执行行为所需当前部件
     * @param {*} [actionContext]  执行行为上下文
     * @memberof IBIZBOOKListViewBase
     */
    public Remove(args: any[],contextJO?:any, params?: any, $event?: any, xData?: any,actionContext?:any,srfParentDeName?:string) {
        const _this: any = this;
        if (!xData || !(xData.remove instanceof Function)) {
            return ;
        }
        xData.remove(args);
    }


    /**
     * 转化数据
     *
     * @param {any} args
     * @memberof  LnternalFuncListBase
     */
    public transformData(args: any) {
        let _this: any = this;
        if(_this.service && _this.service.handleRequestData instanceof Function && _this.service.handleRequestData('transform',_this.context,args)){
            return _this.service.handleRequestData('transform',_this.context,args)['data'];
        }
    }

    /**
     * 关闭视图
     *
     * @param {any} args
     * @memberof LnternalFuncListBase
     */
    public closeView(args: any): void {
        let _this: any = this;
        _this.$emit('closeview', [args]);
    }

    /**
     *  计数器刷新
     *
     * @memberof LnternalFuncListBase
     */
    public counterRefresh(){
        const _this:any =this;
        if(_this.counterServiceArray && _this.counterServiceArray.length >0){
            _this.counterServiceArray.forEach((item:any) =>{
                if(item.refreshData && item.refreshData instanceof Function){
                    item.refreshData();
                }
            })
        }
    }



    /**
     * 代码表服务对象
     *
     * @type {CodeListService}
     * @memberof LnternalFuncListBase
     */  
    public codeListService:CodeListService = new CodeListService({ $store: this.$store });

    /**
     * 获取多项数据
     *
     * @returns {any[]}
     * @memberof LnternalFuncListBase
     */
    public getDatas(): any[] {
        return this.selections;
    }

    /**
     * 获取单项树
     *
     * @returns {*}
     * @memberof LnternalFuncListBase
     */
    public getData(): any {
        return null;
    }

    /**
     * 是否默认选中第一条数据
     *
     * @type {boolean}
     * @memberof LnternalFuncListBase
     */
    @Prop({ default: false }) public isSelectFirstDefault!: boolean;

    /**
     * 显示处理提示
     *
     * @type {boolean}
     * @memberof LnternalFuncListBase
     */
    @Prop({ default: true }) public showBusyIndicator?: boolean;

    /**
     * 部件行为--create
     *
     * @type {string}
     * @memberof LnternalFuncListBase
     */
    @Prop() public createAction!: string;

    /**
     * 部件行为--remove
     *
     * @type {string}
     * @memberof LnternalFuncListBase
     */
    @Prop() public removeAction!: string;

    /**
     * 部件行为--update
     *
     * @type {string}
     * @memberof LnternalFuncListBase
     */
    @Prop() public updateAction!: string;

    /**
     * 部件行为--fetch
     *
     * @type {string}
     * @memberof LnternalFuncListBase
     */
    @Prop() public fetchAction!: string;

    /**
     * 打开新建数据视图
     *
     * @type {any}
     * @memberof LnternalFuncListBase
     */
    @Prop() public newdata: any;
    /**
     * 打开编辑数据视图
     *
     * @type {any}
     * @memberof LnternalFuncListBase
     */
    @Prop() public opendata: any;

    /**
     * this引用
     *
     * @type {number}
     * @memberof LnternalFuncListBase
     */
    public thisRef: any = this;




          /**
     * 工具栏模型
     *
     * @type {*}
     * @memberof IBIZBOOKListView
     */
    public listviewlist_quicktoolbarModels: any = {
        deuiaction1: { name: 'deuiaction1', actiontarget: 'NONE', caption: '新建', disabled: false, type: 'DEUIACTION', visabled: true,noprivdisplaymode:2,dataaccaction: '', uiaction: { tag: 'New', target: '' } },

    };


          /**
     * 工具栏模型
     *
     * @type {*}
     * @memberof IBIZBOOKListView
     */
    public listviewlist_batchtoolbarModels: any = {
        deuiaction1: { name: 'deuiaction1', actiontarget: 'NONE', caption: '编辑', disabled: false, type: 'DEUIACTION', visabled: true,noprivdisplaymode:2,dataaccaction: '', uiaction: { tag: 'Edit', target: 'SINGLEKEY' } },

        deuiaction2: { name: 'deuiaction2', actiontarget: 'NONE', caption: '删除', disabled: false, type: 'DEUIACTION', visabled: true,noprivdisplaymode:2,dataaccaction: '', uiaction: { tag: 'Remove', target: 'MULTIKEY' } },

    };


    /**
     * 当前页
     *
     * @type {number}
     * @memberof LnternalFuncListBase
     */
    public curPage: number = 1;

    /**
     * 数据
     *
     * @type {any[]}
     * @memberof LnternalFuncListBase
     */
    public items: any[] = [];

    /**
     * 是否支持分页
     *
     * @type {boolean}
     * @memberof LnternalFuncListBase
     */
    public isEnablePagingBar: boolean = true;

    /**
     * 分页条数
     *
     * @type {number}
     * @memberof LnternalFuncListBase
     */
    public limit: number = 1000;

    /**
     * 总条数
     *
     * @type {number}
     * @memberof LnternalFuncListBase
     */
    public totalRecord: number = 0;

    /**
     * 加载的数据是否附加在items之后
     *
     * @type {boolean}
     * @memberof LnternalFuncListBase
     */
    public isAddBehind:boolean = false;

    /**
     * 是否有滚动条
     *
     * @type {boolean}
     * @memberof LnternalFuncListBase
     */
    public isScrollBar: boolean = false;

    /**
     * 排序方向
     *
     * @type {string}
     * @memberof LnternalFuncListBase
     */    
    public sortDir:string = 'asc';

    /**
     * 排序字段
     *
     * @type {string}
     * @memberof LnternalFuncListBase
     */    
    public sortField: string = 'ibizbookname';

    /**
     * 选中数组
     * @type {Array<any>}
     * @memberof LnternalFuncListBase
     */
    public selections: Array<any> = [];

    /**
     * 应用状态事件
     *
     * @public
     * @type {(Subscription | undefined)}
     * @memberof LnternalFuncListBase
     */
    public appStateEvent: Subscription | undefined;

     /**
     * Vue声明周期，组件挂载完毕
     *
     * @memberof LnternalFuncListBase
     */
    public mounted () {
        this.afterMounted();
    }

    /**
     * 执行mounted后的逻辑
     *
     * @memberof LnternalFuncListBase
     */
    public afterMounted () {
        const loadMoreCallBack:any = this.throttle(this.loadMore,3000);
        this.$el.addEventListener('scroll', ()=> {
            if(this.$el.scrollHeight > this.$el.clientHeight) {
                this.isScrollBar = true;
            } else {
                this.isScrollBar = false;
            }
            if( this.$el.scrollTop +  this.$el.clientHeight  >=  this.$el.scrollHeight) {
                loadMoreCallBack();
            }
        })
    }

    /**
     * Vue声明周期，组件创建完毕
     *
     * @memberof LnternalFuncListBase
     */
    public created() {
        this.afterCreated()
    }

    /**
     * 执行created后的逻辑
     *
     *  @memberof LnternalFuncListBase
     */    
    public afterCreated(){
        if (this.viewState) {
            this.viewStateEvent = this.viewState.subscribe(({ tag, action, data }) => {
                if (!Object.is(this.name, tag)) {
                    return;
                }
                if (Object.is(action,'load')) {
                    this.curPage = 1;
                    this.items = [];
                    this.load(data);
                }
                if (Object.is(action,'refresh')) {
                    this.refresh(data);
                }
            });
        }
        if(AppCenterService && AppCenterService.getMessageCenter()){
            this.appStateEvent = AppCenterService.getMessageCenter().subscribe(({ name, action, data }) =>{
                if(!Object.is(name,"IBIZBOOK")){
                    return;
                }
                if(Object.is(action,'appRefresh')){
                    this.refresh([data]);
                }
            })
        }
    }    

    /**
     * vue 生命周期
     *
     * @memberof LnternalFuncListBase
     */
    public destroyed() {
        this.afterDestroy();
    }

    /**
     * 执行destroyed后的逻辑
     *
     * @memberof LnternalFuncListBase
     */
    public afterDestroy() {
        if (this.viewStateEvent) {
            this.viewStateEvent.unsubscribe();
        }
        if(this.appStateEvent){
            this.appStateEvent.unsubscribe();
        }
    }    

    /**
    * 加载更多
    *
    * @memberof LnternalFuncListBase
    */
    public loadMore(){
        if(this.totalRecord>this.items.length){
            this.curPage = ++this.curPage;
            this.isAddBehind = true;
            this.load({});
        }
    }

    /**
     * 刷新
     *
     * @param {*} [args={}]
     * @memberof Main
     */
    public refresh(args?: any) {
        this.isAddBehind = true;
        this.load(args);
    }

    /**
     * 列表数据加载
     *
     * @public
     * @param {*} [arg={}]
     * @memberof LnternalFuncListBase
     */
    public load(opt: any = {}): void {
        if(!this.fetchAction){
            this.$Notice.error({ title: (this.$t('app.commonWords.wrong') as string), desc: 'IBIZBOOKListView' + (this.$t('app.list.notConfig.fetchAction') as string) });
            return;
        }        
        const arg: any = {...opt};
        const page: any = {};
        if (this.isEnablePagingBar) {
            Object.assign(page, { page: this.curPage-1, size: this.limit });
        }
        // 设置排序
        if (!Object.is(this.sortDir, '') && !Object.is(this.sortField, '')) {
          const sort: string = this.sortField+","+this.sortDir;
            Object.assign(page, { sort: sort });
        }
        Object.assign(arg, page);
        const parentdata: any = {};
        this.$emit('beforeload', parentdata);
        Object.assign(arg, parentdata);
        let tempViewParams:any = parentdata.viewparams?parentdata.viewparams:{};
        if(this.viewparams){
            Object.assign(tempViewParams,JSON.parse(JSON.stringify(this.viewparams)));
        }
        Object.assign(arg,{viewparams:tempViewParams});
        const post: Promise<any> = this.service.search(this.fetchAction, this.context?JSON.parse(JSON.stringify(this.context)):{}, arg, this.showBusyIndicator);
        post.then((response: any) => {
            if (!response || response.status !== 200) {
                if (response.errorMessage) {
                    this.$Notice.error({ title: (this.$t('app.commonWords.wrong') as string), desc: response.errorMessage });
                }
                return;
            }
            const data: any = response.data;
            if(!this.isAddBehind){
                this.items = [];
            }
            if (data && data.length > 0) {
                let datas = JSON.parse(JSON.stringify(data));
                datas.map((item: any) => {
                    Object.assign(item, { isselected: false });
                });
                this.totalRecord = response.total;
                this.items.push(...datas);
                this.items = this.arrayNonRepeatfy(this.items);
            }
            this.isAddBehind = false;
            this.$emit('load', this.items);
            //在导航视图中，如已有选中数据，则右侧展开已选中数据的视图，如无选中数据则默认选中第一条
            if(this.isSelectFirstDefault){
                if(this.selections && this.selections.length > 0){
                    this.selections.forEach((select: any)=>{
                        const index = this.items.findIndex((item:any) => Object.is(item.srfkey,select.srfkey));
                        if(index != -1){
                            this.handleClick(this.items[index]);
                        }
                    })
                }else{
                    this.handleClick(this.items[0]);
                } 
            }
        }, (response: any) => {
            if (response && response.status === 401) {
                return;
            }
            this.$Notice.error({ title: (this.$t('app.commonWords.wrong') as string), desc: response.errorMessage });
        });
    }

    /**
     * 列表数据去重
     *
     * @param {Array<any>} [arr]
     * @returns {void}
     * @memberof LnternalFuncListBase
     */
    public arrayNonRepeatfy(arr:Array<any>) {
        let map = new Map();
        let array = new Array();
        for (let i = 0; i < arr.length; i++) {
            map .set(arr[i].srfkey, arr[i]); 
        }
        map.forEach((value:any, key:string, map:any) => {
            array.push(value);
        });
        return array ;
    }

    /**
     * 节流
     *
     * @param {Array<any>} [arr]
     * @returns {void}
     * @memberof LnternalFuncListBase
     */
    public throttle(fn:any, wait:number){
        let time = 0;
        return () =>{
          let now = Date.now()
          let args = arguments;
          if(now - time > wait){
            fn.apply(this, args)
            time = now;
          }
        }
    }

    /**
     * 删除
     *
     * @param {any[]} datas
     * @returns {Promise<any>}
     * @memberof LnternalFuncListBase
     */
    public async remove(datas: any[]): Promise<any> {
        if(!this.removeAction){
            this.$Notice.error({ title: (this.$t('app.commonWords.wrong') as string), desc: 'IBIZBOOKListView' + (this.$t('app.list.notConfig.removeAction') as string) });
            return;
        }
        if (datas.length === 0) {
            return;
        }
        let dataInfo = '';
        datas.forEach((record: any, index: number) => {
            let srfmajortext = record.srfmajortext;
            if (index < 5) {
                if (!Object.is(dataInfo, '')) {
                    dataInfo += '、';
                }
                dataInfo += srfmajortext;
            } else {
                return false;
            }
        });

        if (datas.length < 5) {
            dataInfo = dataInfo + ' 共' + datas.length + '条数据';
        } else {
            dataInfo = dataInfo + '...' + ' 共' + datas.length + '条数据';
        }

        const removeData = () => {
            let keys: any[] = [];
            datas.forEach((data: any) => {
                keys.push(data.srfkey); 
            });
            let _removeAction = keys.length > 1 ? 'removeBatch' : this.removeAction ;
            const context:any = JSON.parse(JSON.stringify(this.context));
            const post: Promise<any> = this.service.delete(_removeAction,Object.assign(context,{ ibizbook: keys.join(';') }),Object.assign({ ibizbook: keys.join(';') },{viewparams:this.viewparams}), this.showBusyIndicator);
            return new Promise((resolve: any, reject: any) => {
                post.then((response: any) => {
                    if (!response || response.status !== 200) {
                        this.$Notice.error({ title: '', desc: (this.$t('app.commonWords.delDataFail') as string) + ',' + response.info });
                        return;
                    } else {
                        this.$Notice.success({ title: '', desc: (this.$t('app.commonWords.deleteSuccess') as string) });
                    }
                    //删除items中已删除的项
                    datas.forEach((data: any) => {
                        this.items.some((item:any,index:number)=>{
                            if(Object.is(item.srfkey,data.srfkey)){
                                this.items.splice(index,1);
                                return true;
                            }
                        });
                    });
                    this.$emit('remove', null);
                    this.selections = [];
                    resolve(response);
                }).catch((response: any) => {
                    if (response && response.status === 401) {
                        return;
                    }
                    if (!response || !response.status || !response.data) {
                        this.$Notice.error({ title: (this.$t('app.commonWords.wrong') as string), desc: (this.$t('app.commonWords.sysException') as string) });
                        reject(response);
                        return;
                    }
                    reject(response);
                });
            });
        }

        dataInfo = dataInfo.replace(/[null]/g, '').replace(/[undefined]/g, '').replace(/[ ]/g, '');
        this.$Modal.confirm({
            title: (this.$t('app.commonWords.warning') as string),
            content: (this.$t('app.list.confirmDel') as string) + ' ' + dataInfo + '，' + (this.$t('app.list.notRecoverable') as string) ,
            onOk: () => {
                removeData();
            },
            onCancel: () => { }
        });
        return removeData;
    }

    /**
     * 保存
     *
     * @param {*} $event
     * @returns {Promise<any>}
     * @memberof LnternalFuncListBase
     */
    public async save(args: any[], params?: any, $event?: any, xData?: any){
        let _this = this;
        let successItems:any = [];
        let errorItems:any = [];
        let errorMessage:any = [];
        for (const item of _this.items) {
            try {
                if(Object.is(item.rowDataState, 'create')){
                    if(!this.createAction){
                        this.$Notice.error({ title: (this.$t('app.commonWords.wrong') as string), desc: 'IBIZBOOKListView' + (this.$t('app.list.notConfig.createAction') as string) });
                    }else{
                      Object.assign(item,{viewparams:this.viewparams});
                      let response = await this.service.add(this.createAction, JSON.parse(JSON.stringify(this.context)),item, this.showBusyIndicator);
                      successItems.push(JSON.parse(JSON.stringify(response.data)));
                    }
                }else if(Object.is(item.rowDataState, 'update')){
                    if(!this.updateAction){
                        this.$Notice.error({ title: (this.$t('app.commonWords.warning') as string), desc: 'IBIZBOOKListView' + (this.$t('app.list.notConfig.updateAction') as string) });
                    }else{
                        Object.assign(item,{viewparams:this.viewparams});
                        if(item.ibizbook){
                            Object.assign(this.context,{ibizbook:item.ibizbook});
                        }
                        let response = await this.service.add(this.updateAction,JSON.parse(JSON.stringify(this.context)),item, this.showBusyIndicator);
                        successItems.push(JSON.parse(JSON.stringify(response.data)));
                    }
                }
            } catch (error) {
                errorItems.push(JSON.parse(JSON.stringify(item)));
                errorMessage.push(error);
            }
        }
        this.$emit('save', successItems);
        this.refresh();
        if(errorItems.length === 0){
            this.$Notice.success({ title: '', desc: (this.$t('app.commonWords.saveSuccess') as string) });
        }else{
          errorItems.forEach((item:any,index:number)=>{
            this.$Notice.error({ title: (this.$t('app.commonWords.saveFailed') as string), desc: item.majorentityname+ (this.$t('app.commonWords.saveFailed') as string) + '!' });
            console.error(errorMessage[index]);
          });
        }
        return successItems;
    }

    /**
     * 面板数据变化处理事件
     * @param {any} item 当前列数据
     * @param {any} $event 面板事件数据
     *
     * @memberof LnternalFuncListBase
     */
    public onPanelDataChange(item:any,$event:any) {
        Object.assign(item, $event, {rowDataState:'update'});
    }

    /**
     * 选择数据
     * @memberof LnternalFuncListBase
     *
     */
    public handleClick(args: any) {
        this.clearSelection();
        args.isselected = !args.isselected;
        this.selectchange();
    }

    /**
     * 双击数据
     * @memberof LnternalFuncListBase
     *
     */
    public handleDblClick(args: any) {
        this.$emit('rowdblclick', args);
    }

    /**
     * 触发事件
     * @memberof LnternalFuncListBase
     *
     */
    public selectchange() {
        this.selections = [];
        this.items.map((item: any) => {
            if (item.isselected) {
                this.selections.push(item);
            }
        });
        this.$emit('selectionchange', this.selections);
    }

    /**
     * 清除当前所有选中状态
     *
     * @memberof LnternalFuncListBase
     */
    public clearSelection(){
        this.items.map((item: any) => {
            Object.assign(item, { isselected: false });
        }); 
    }

    /**
     * 操作栏模型数据
     *
     * @type {*}
     * @memberof LnternalFuncListBase
     */ 
    public ActionModel:any ={
        "New":{name:"New",icon:"fa fa-file-text-o",caption:"新建",disabled: false, visabled: true,noprivdisplaymode:2,dataaccaction: "", actiontarget: ""},
        "Edit":{name:"Edit",icon:"fa fa-edit",caption:"编辑",disabled: false, visabled: true,noprivdisplaymode:2,dataaccaction: "", actiontarget: "SINGLEKEY"},
        "Remove":{name:"Remove",icon:"fa fa-remove",caption:"删除",disabled: false, visabled: true,noprivdisplaymode:2,dataaccaction: "", actiontarget: "MULTIKEY"}
    };

    /**
     * 操作列界面行为
     *
     * @param {*} data
     * @param {*} tag
     * @param {*} $event
     * @memberof LnternalFuncListBase
     */
	public uiAction(data: any, tag: any, $event: any) {
        $event.stopPropagation();
        if(Object.is('New', tag)) {
            this.list_quicktoolbar_deuiaction1_click(data, tag, $event);
        }
        if(Object.is('Edit', tag)) {
            this.list_batchtoolbar_deuiaction1_click(data, tag, $event);
        }
        if(Object.is('Remove', tag)) {
            this.list_batchtoolbar_deuiaction2_click(data, tag, $event);
        }
    }

}
</script>

<style lang='less'>
@import './lnternal-func-list-list.less';
</style>